import {Dependency, ImpType} from '../core/Dispatcher.js'

declare module "./type" {
   interface GenericImpTypes<T> {
      unequal: (a: T, b:T) => boolean
   }
}

export const unequal =
   <T>(dep: Dependency<'equal', [T,T]>): ImpType<'unequal', [T, T]> =>
   (a, b) => !dep.equal(a, b)
